﻿#target indesign
#targetengine "jp.co.matsuzawa.jidori"
function main(){
    var jidoriSu=0;
    if(app.selection.length>0){
        app.scriptPreferences.measurementUnit=MeasurementUnits.MILLIMETERS;
        var sel=app.selection[0];
        if(sel.constructor.name==="TextFrame"){
            if("contents" in sel.parent){
                sel.parentStory.texts[0].duplicate(LocationOptions.AFTER,sel.parent);
                sel.remove();
                exit();
            }else{
                alert("この選択範囲では処理できません。");
                exit();
            }
        }
        if("contents" in sel){
            var ps=sel.characters.firstItem().pointSize;
            var setting=app.extractLabel("jp.co.matsuzawa.jidori1");
            var settingFlg=app.extractLabel("jp.co.matsuzawa.jidori2");
            jidoriSu=(setting!="")? Number(setting): sel.contents.length;
            settingFlg=(settingFlg!="")? eval(settingFlg): false;
            var dlg=new Window('dialog','インラインテキストフレームで字取り',undefined,{borderless:false});
            dlg.orientation='column';
            var fontObj1=ScriptUI.newFont(dlg.graphics.font.family,dlg.graphics.font.style,16);
            var fontObj2=ScriptUI.newFont(dlg.graphics.font.family,dlg.graphics.font.style,24);
            var fontObj3=ScriptUI.newFont(dlg.graphics.font.family,dlg.graphics.font.style,32);
            var gp01=dlg.add('group',undefined);
            gp01.spacing=6;
            gp01.orientation='column';
            gp01.alignChildren='left';
            var gp02=gp01.add('group',undefined);
            var mjGui=gp02.add("EditText { properties:{multiline:false}, text:'"+jidoriSu+"', justify:'center'}");
            mjGui.size=[fontObj3.size*2.5,42];
            mjGui.graphics.font=fontObj3;
            var st=gp02.add('staticText',undefined,"文字分");
            st.graphics.font=fontObj1;
            dlg.spDel=gp01.add('checkbox',undefined,"スペースを除去する");
            dlg.spDel.graphics.font=fontObj1;
            dlg.spDel.value=settingFlg;
            var makeProc=gp02.add('button',undefined,"生成",{name:'ok'});
            makeProc.graphics.font=fontObj2;
            makeProc.preferredSize.height+=16;
            if(dlg.show()===1){
                sel.jidori=0;
                sel.appliedConditions=["None"];
                var changeJidori=Number(mjGui.text);
                var haba=(changeJidori*ps);
                var takasa=ps;
                var newBox=sel.insertionPoints.lastItem().textFrames.add();
                sel.duplicate(LocationOptions.AFTER,newBox.parentStory);
                var barr=newBox.visibleBounds;
                barr[3]=barr[1]+haba;
                barr[2]=barr[0]+takasa;
                newBox.visibleBounds=barr;
                newBox.parentStory.firstLineIndent=
                    newBox.parentStory.leftIndent=
                    newBox.parentStory.rightIndent=0;
                newBox.parentStory.spaceBefore=
                    newBox.parentStory.spaceAfter=0;
                newBox.parentStory.justification=Justification.FULLY_JUSTIFIED;
                newBox.parentStory.gridAlignment=GridAlignment.NONE;
                newBox.parentStory.textFrames[0].remove();
                sel.characters.itemByRange(sel.characters[0],sel.characters[sel.characters.length-2]).remove();
                if(dlg.spDel.value){
                    for(var zzz=newBox.parentStory.characters.length-1;zzz>-1;zzz--){
                        if(newBox.parentStory.characters[zzz].contents.match(/\s/)){
                            newBox.parentStory.characters[zzz].remove();
                        }
                    }
                }
                app.insertLabel("jp.co.matsuzawa.jidori1",(""+changeJidori));
                app.insertLabel("jp.co.matsuzawa.jidori2",(""+dlg.spDel.value));
            }else{
                alert("キャンセルしました。");
                exit();
            }
        }
    }
}
app.doScript(main, ScriptLanguage.JAVASCRIPT, [], UndoModes.ENTIRE_SCRIPT);